﻿
var disableReload = false;
function openCompanyColumnSettings() {
    $("#dialog-company-column-settings").html("<div class='loading-32'></div>");
    $("#dialog-company-column-settings").dialog("open");
    $("#dialog-company-column-settings").load(RQ_URL + "/Customers/LoadFields", function () {
        disableReload = true;
        $("#dialog-company-column-settings").dialog("close");
        $("#dialog-company-column-settings").dialog("open");
    });
}

function formatIsApprovedAndLockedOut(cellValue, options, rowObject) {
    var html = '<i class="fa fa-lg ' + (rowObject.IsApproved ? 'fa-check' : 'fa-times') + '" aria-hidden="true" style="color: ' + (rowObject.IsApproved ? '#4F9F4F' : '#990000;') + ';"></i>' + (rowObject.IsLockedOut ? ' <i class="fa fa-lg fa-lock" aria-hidden="true" style="color: #990000;"></i>' : '');
    return html;
}

function numberFormatter(cellValue, options, rowObject) {
    var nameLinkHtml = "<div style='margin-right:5px'>" + cellValue + "</div>";
    return nameLinkHtml;
}

function userLinkFormatter(cellValue, options, rowObject) {
    var nameLinkHtml = "<div style='margin-right:5px'><a href='" + RQ_URL + "/Customers/Edit/" + rowObject.Id + "?tab=2'>" + cellValue + "</a></div>";
    return nameLinkHtml;
}

function numberOfTicketsFormatter(cellValue, options, rowObject) {
    var nameLinkHtml = "<div style='margin-right:5px'><a href='" + RQ_URL + "/Customers/Edit/" + rowObject.Id + "?tab=5'><span data-toggle='tooltip' title='" + Localization_Customer_TicketsOpen + "'>" + cellValue + "</span></a> / <a href='" + RQ_URL + "/Customers/Edit/" + rowObject.Id + "?tab=5'><span data-toggle='tooltip' title='" + Localization_Customer_TicketsClosed + "' class='gray'>" + rowObject.NumberOfClosedTickets + "</span></a></div>";
    return nameLinkHtml;
}

function logoFormatter(cellValue, options, rowObject) {
    var boolHtml = cellValue == false ? "<i class='fa fa-building-o fa-2x' ></i>" : "<img src='" + RQ_URL + "/Customers/GetIcon/" + rowObject.Id + "' />";
    return boolHtml;
}

function webFormat(cellValue, options, rowObject) {
    return (cellValue == "" || cellValue == null ? "" : "<a href='" + (cellValue.indexOf("://") == -1 ? "//" + cellValue : cellValue) + "'>" + cellValue + "</a>");
}

function groupsFormat(cellValue, options, rowObject) {
    var html = "";
    if (cellValue != null) {
        html += "<div>";
        for (var i = 0; i < cellValue.length; i++) {
            if (i != 0)
                html += ", ";
            html += "<i class='fas fa-object-group' style='color:" + cellValue[i].Color + "'></i> <a href='" + RQ_URL + "/Admin/CustomerGroups/Edit/" + cellValue[i].Id + "'>" + cellValue[i].Name + "</a>";
        }
        html += "</div>";
    }
    else {
        html += "<div></div>";
    }
    return html;
}

function tagFormat(cellValue, options, rowObject) {
    var html = "";
    if (cellValue != null) {
        html += "<div class='ticket-tags'>";
        for (var i = 0; i < cellValue.length; i++) {
            html += "<div class='ticket-tag' style='background-color: " + cellValue[i].BackgroundColor + "; color: " + cellValue[i].TextColor + "; border-color:" + cellValue[i].BorderColor + "'>" + cellValue[i].Name + "</div>";
        }
        html += "</div>";
    }
    else {
        html += "<div></div>";
    }
    return html;
}

function emailsFormat(cellValue, options, rowObject) {
    if (cellValue == null || cellValue == '') {
        return "<div></div>";
    }
    else {
        var arr = cellValue.split(';');

        var aHtml = "";
        for (var i = 0; i < arr.length; i++) {
            aHtml += "<a href='mailto:" + arr[i] + "'>" + arr[i] + "</a>, ";
        }
        return "<div>" + aHtml + "</div>";
    }
}

function userFormat(cellValue, options, rowObject) {
    var userHtml = "<a href='" + RQ_URL + "/Customers/User/" + rowObject.UserProviderKey + "'>" + cellValue + "</a>";
    return userHtml;
}

function companyFormatter(cellValue, options, rowObject) {
    var companyHtml = cellValue != null ? "<a href='" + RQ_URL + "/Customers/Edit/" + rowObject.Id + "'>" + cellValue + "</a>" : "";
    return companyHtml;
}

function userCompanyFormatter(cellValue, options, rowObject) {
    var companyHtml = cellValue != null ? "<a href='" + RQ_URL + "/Customers/Edit/" + rowObject.CustomerId + "'>" + cellValue + "</a>" : "";
    return companyHtml;
}

function formatAvatar(cellValue, options, rowObject) {
    return cellValue;
}

function customFieldFormatter(cellValue, options, rowObject) {
    var name = options.colModel.name;
    var obj = jQuery.grep(rowObject.CustomerFields, function (n, i) {
        return (n.Id == name);
    });
    if (obj.length > 0) {
        var o = obj[0];
        switch (o.Type) {
            //DropDown
            case 1:
                if (o.SelectValue == null)
                    return "";
                return o.SelectValue;
                break;
            //Textbox, Multiline
            case 2:
            case 3:
            case 13:
                if (o.TextBoxValue == null)
                    return "";
                return o.TextBoxValue;
                break;
            //Url
            case 12:
                return (o.TextBoxValue == "" || o.TextBoxValue == null ? "" : "<a href='" + (o.TextBoxValue.indexOf("://") == -1 ? "//" + o.TextBoxValue : o.TextBoxValue) + "'>" + o.TextBoxValue + "</a>");
            //Numberic
            case 4:
                if (o.LongValue == null)
                    return "";
                return o.LongValue;
                break;
            //Decimal
            case 5:
                if (o.DoubleValue == null)
                    return "";
                return o.DoubleValue;
                break;
            //Checkbox
            case 6:
                if (o.CheckBoxValue == null)
                    return "";
                return o.CheckBoxValue == true ? ' <i class="fa fa-check" aria-hidden="true" data-toggle="tooltip" title="' + Localization_Yes + '"></i>' : '<i class="fa fa-ban" aria-hidden="true" data-toggle="tooltip" title="' + Localization_No + '"></i>';
                break;
            //Date
            case 10:
                if (o.DateValue == null)
                    return "";
                return o.DateValue;
                break;

        }
    }
    return "";
}

function myActions(cellValue, options, rowObject) {
    var actionHtml = "<a data-toggle='tooltip' title='" + Localization_Edit + "' href='" + RQ_URL + "/Customers/Edit/" + rowObject.Id + "' class='jqgrid-bootstrap-table-edit' ><i class=\"fa fa-pencil-square-o fa-lg\"></i></a>&nbsp;&nbsp;<a class='deleteLink jqgrid-bootstrap-table-delete' data-toggle='tooltip' title='" + Localization_Delete +"' href='" + RQ_URL + "/Customers/Delete/" + rowObject.Id + "' ><i class=\"fa fa-trash-o fa-lg\"></i></a>";
    return actionHtml;
}

function myUserActions(cellValue, options, rowObject) {
    var actionHtml = "<a data-toggle='tooltip' title='" + Localization_Edit + "' href='" + RQ_URL + "/Customers/User/" + rowObject.UserProviderKey + "' class='jqgrid-bootstrap-table-edit' ><i class=\"fa fa-pencil-square-o fa-lg\"></i></a>";
    actionHtml += "&nbsp;&nbsp;<a class='deleteUserLink jqgrid-bootstrap-table-delete' data-toggle='tooltip' data-fullname='" + rowObject.FullName + "' title='" + Localization_Delete +"' href='" + RQ_URL + "/Account/Delete/" + rowObject.UserProviderKey + "'\"><i class=\"fa fa-trash-o fa-lg\"></i></a>";
    return actionHtml;
}

function formatBool(cellValue, options, rowObject) {
    var boolHtml = cellValue == false ? ' <i class="fa fa-check" aria-hidden="true" data-toggle="tooltip" title="' + Localization_Enabled + '"></i>' : '<i class="fa fa-ban" aria-hidden="true" data-toggle="tooltip" title="' + Localization_Disabled +'"></i>';
    return boolHtml;
}