﻿//stary puvodni import obecně na .../Administration/Import

$(document).ready(function () {
    InitUploader($("#identifierForAsyncAttachments").val());

    $("#dialog-confirm-import").dialog({
        autoOpen: false,
        modal: true,
        resizable: false,
    });



});


var uploader;

function InitUploader(identifierForAsyncAttachments) {

    uploader = new plupload.Uploader({
        runtimes: 'html5,flash,silverlight',
        url: RQ_URL + '/Administration/UploadImportXmlAjax',
        browse_button: 'pickfiles',
        container: 'containerAttachments',
        max_file_size: '1024mb',
        chunk_size: '1024kb',
        unique_names: false,
        multiple_queues: false,
        multi_selection: false,
        multipart_params: { identifierForAsyncAttachments: identifierForAsyncAttachments },
        flash_swf_url: RQ_URL + '/Scripts/plupload/Moxie.swf',
        silverlight_xap_url: RQ_URL + '/Scripts/plupload/Moxie.xap',
    });

    uploader.bind('Init', function (up, params) {
        $('#filelist').html("<ul id=\"filelistul\"></ul>");
    });

    uploader.init();

    uploader.bind('UploadProgress', function (up, file) {
        $('#up-progress').attr("style", "width: " + file.percent + "%;");
        $('#lbUploadFileSize').html(formatSize(file.loaded));
        $('#lbUploadPercentage').html(file.percent);        
    });

    uploader.bind('Error', function (up, err) {
        if (err.code == -600)
            $('#filelist').append('<div class="valid-error">Error: File size is greater than 1000 MB' + (err.file ? ', File: ' + err.file.name : "") + '</div>');
        else
            $('#filelist').append("<div class='valid-error'>Error: " + err.code + ", Message: " + err.message + (err.file ? ", File: " + err.file.name : "") + "</div>");

        up.refresh(); // Reposition Flash/Silverlight
    });

    var total_upload_files = 0;

    uploader.bind('QueueChanged', function (up, files) {
        total_upload_files = uploader.files.length;

        $('#olSteps li').removeClass();
        $('.hidden').hide();
        $('.valid-error').hide();
        $("#upload-status").show();
        uploader.start();

        SetStepActive(1);
    });

    uploader.bind('FileUploaded', function (up, file) {
        total_upload_files--;
        //$("#upload-status").hide();

        SetStepActive(2);

        $.post(
        RQ_URL + "/Administration/UploadImportXmlAjaxCompleted",
        { identifierForAsyncAttachments: $("#identifierForAsyncAttachments").val(), },
        function (data) {
            if (data.success) {
                $("#ulAnalyzing").show();
                $("#lbUsers").text(data.users);
                $("#lbCustomers").text(data.customers);
                $("#lbInternalGroups").text(data.internalgroups);
                $("#lbOperatorGroups").text(data.operatorgroups);
                $("#lbServices").text(data.services);
                $("#lbTickets").text(data.tickets);
                $("#lbTicketMessages").text(data.ticketmessages);
                CheckImportXmlDataIntegrity();
            }
            else {
                SetStepError(2);
                ShowError(data.message);
            }
        },
        "json"
        )
        .error(function (error) { alert(error.responseText); });
    });

}

function ClearImportXmlSession(storeFile) {
    $.post(
    RQ_URL + "/Administration/ClearImportXmlSession",
    { identifierForAsyncAttachments: $("#identifierForAsyncAttachments").val(), storeFile: storeFile },
    "json"
    )
    .error(function (error) { alert(error.responseText); });
}

function SetStepActive(number) {
    if (number > 1) {
        var prevLi = $('#olSteps > li:nth-child(' + (number - 1) + ')');
        prevLi.removeClass();
        prevLi.addClass('valid');
    }
    
    $('#olSteps > li:nth-child(' + number + ')').addClass('checking');
}

function SetStepError(number) {
    var li = $('#olSteps > li:nth-child(' + number + ')');
    li.removeClass();
    li.addClass('error');
}

function CheckImportXmlDataIntegrity() {
    SetStepActive(3);

    $.post(
    RQ_URL + "/Administration/CheckImportXmlDataIntegrity",
    { },
    function (data) {
        if (data.success) {
            $("#dialog-confirm-import").dialog({
                buttons: [
                    {
                        text: Localization_Yes,
                        click: function () {
                            $("#dialog-confirm-import").dialog('close');
                            SetStepActive(4);
                            $('#doNotCloseBrowser').show();
                            $('#lbImporting').show();
                            ImportAdministrationStuff();
                        }
                    },
                    {
                        text: Localization_No,
                        click: function () {
                            $("#dialog-confirm-import").dialog('close');
                            ClearImportXmlSession(false);
                        }
                    }
                ]
            });

            $("#dialog-confirm-import").dialog('open');
        }
        else {
            SetStepError(3);
            ShowError(data.message);
            $('#tbErrors').text(data.errors);
            $('#divErrors').show();
            ClearImportXmlSession(false);
        }
    },
    "json"
    )
    .error(function (error) { alert(error.responseText); });
}

function ImportAdministrationStuff() {
    $('#lbImporting').text(' - Administration stuff')

    $.post(
    RQ_URL + "/Administration/ImportAdministrationStuff",
    {  },
    function (data) {
        var ticketsCount = data.ticketsCount;

        if (data.success) {
            ImportTickets(0, ticketsCount);
        }
        else {
            SetStepError(4);
            ShowError(data.message);
            ClearImportXmlSession(false);
        }
    },
    "json"
    )
    .error(function (error) { alert(error.responseText); });
}


function ImportTickets(ticketImportIndex, ticketsCount) {
    $('#lbImporting').text(' - Tickets: ' + (ticketImportIndex + 1) + '/' + ticketsCount + ' (' + Math.round((ticketImportIndex + 1) * 100 / ticketsCount) + ' %)')
    
    $.post(
    RQ_URL + "/Administration/ImportTicket",
    { index: ticketImportIndex },
    function (data) {
        if (data.success) {
            if (data.indexLastImported + 1 < ticketsCount) {
                ImportTickets(data.indexLastImported + 1, ticketsCount);
            }
            else {
                SetStepActive(5);
                $('#doNotCloseBrowser').hide();
                $('#liComplete').show();
                ClearImportXmlSession(true);
                ShowInformation("Congratulations, all the data were imported.");
            }
        }
        else {
            SetStepError(4);
            ShowError(data.message);
            ClearImportXmlSession(false);
        }
    },
    "json"
    )
    .error(function (error) { alert(error.responseText); });    
}

function formatSize(bytes) {
    if (bytes < 10 * 1024)
        return bytes + "&nbsp;B";
    else if (bytes < 10 * 1024 * 1024)
        return Math.round(bytes / 1024) + "&nbsp;kB";
    else
        return Math.round(bytes / 1024 / 1024) + "&nbsp;MB";
}