﻿$(document).ready(function () {
    /// SECTION GOALS ///
    $('#tableOfGoals').on('click', '#btAddGoal', function () {
        AddGoal();
    });

    InitSortableRows();

    /// SECTION ESCALATIONS ///
    $('#tableOfEscalations').on('change', '#ddlEscalationImmediatelyBeforeAfter', function () {
        if ($(this).val() == "0") {
            $('#spanEscalationTimeOut').hide();
        } else {
            $('#spanEscalationTimeOut').show();
        }
    });

    $('#tableOfEscalations').on('click', '#btAddEscalation', function () {
        AddEscalation();
    });

    $('#tableOfEscalations').on('change', '.ddlEscalationImmediatelyBeforeAfter', function () {
        var spanEscalationTimeOut = $(this).parent().find('.spanEscalationTimeOut');

        if ($(this).val() == "0") {
            spanEscalationTimeOut.hide();
        } else {
            spanEscalationTimeOut.show();
        }
    });
});

function AddGoal() {
    $('#spanTimeOutFormat').hide();
    $('#spanNoGoalCondition').hide();

    var error = false;

    if ($('#tbTimeOut').val().trim() != '') {
        if (!(/^ *([0-9]*h)? ?([0-9]*m)? *$/.test($('#tbTimeOut').val()))) {
            $('#spanTimeOutFormat').show();
            error = true;
        }
    }

    if (editedSlaGoalConditions.length == 0) {
        $('#spanNoGoalCondition').show();
        error = true;
    }

    if (!error) {
        $('#btAddGoal').addClass("loading-16");
        //alert($('#hiddenGoalConditionsNew').val());

        editedSlaGoalConditions.push({ name: 'timeout', value: $('#tbTimeOut').val() });
        editedSlaGoalConditions.push({ name: 'calendarId', value: $('#ddlCalendars').val() }); //prida dalsi parametry
        editedSlaGoalConditions.push({ name: 'sendEmail', value: $('#cbSendEmail').is(':checked') }); //prida dalsi parametry
        
        $.post(
            RQ_URL + "/SLAs/AddGoal",
            editedSlaGoalConditions,
             //$('#hiddenGoalConditionsNew').val() + '&' + $.param({ timeout: $('#tbTimeOut').val(), calendarId: $('#ddlCalendars').val() }) //prida dalsi parametry (alternativni funkcni reseni)
            function (data) {
            },
            "json"
            )
            .error(function (error) { alert(error.responseText); })
            .success(function () { ReloadTableOfGoals(); })
            .done(function () { $('#btAddGoal').removeClass("loading-16"); });
    }
}

function ReloadTableOfGoals(quiet) {
    if (!quiet) { OnAjaxBegin(); }

    $("#tableOfGoals").load(
        RQ_URL + "/SLAs/PartialTableOfGoals",
        function () {
            InitSortableRows(); //reinit
            if (!quiet) { OnAjaxComplete(); }
        }
    );
}

function InitSortableRows() {
    $("#tableBodyOfGoals").sortable({
        items: "> tr:not(:last)",
        handle: ".handle",
        update: function (event, ui) {
            var data = $(this).sortable('toArray', { attribute: 'data-index' });

            $.post(
                RQ_URL + "/SLAs/SaveGoalsOrder",
                $.param(
                    { indexes: data },
                    true
                ),
                function (data) {
                },
                "json"
                )
                .error(function (error) { alert(error.responseText); })
                .success(function () { ReloadTableOfGoals(true); })
                .done(function () { });
        }
    });
}

function DeleteGoal(index) {
    OnAjaxBegin();

    $.post(
        RQ_URL + "/SLAs/DeleteGoal",
        {
            index: index,
        },
        "json"
        )
        .error(function (error) { alert(error.responseText); })
        .success(function () { ReloadTableOfGoals(); })
        .done(function () { OnAjaxComplete(); });
}

function EditGoal(index) {
    $('#tableOfGoals tr.goal-item div.editable').hide();
    $('#tableOfGoals tr.goal-item div.readonly').show();

    var tr = $('#tableOfGoals tr[data-index="' + index + '"].goal-item');

    tr.find('div.editable input[type="text"].tbTimeOut').val(tr.find('div.editable input[type="hidden"].tbTimeOut').val());
    tr.find('div.editable select.ddlCalendars').val(tr.find('div.editable input[type="hidden"].ddlCalendars').val());
    tr.find('div.editable input[type="checkbox"].cbSendEmail').val(tr.find('div.editable input[type="hidden"].cbSendEmail').val());
    
    tr.find('div.editable .div-conditions').html(tr.find('div.readonly').html());

    tr.find('div.readonly').hide();
    tr.find('div.editable').show();

    editedSlaGoalConditions = [];
    $('#divGoalConditionNew').empty();

    $.post(
        RQ_URL + "/SLAs/RemoveTempSlaGoalConditions",
        {
        },
        "json"
        )
        .error(function (error) { alert(error.responseText); });
}

function CancelEditGoal(index) {
    var tr = $('#tableOfGoals tr[data-index="' + index + '"].goal-item');
    tr.find('div.editable').hide();
    tr.find('div.readonly').show();
    tr.find('div.editable .spanTimeOutFormat').hide();
    tr.find('div.editable .spanNoGoalCondition').hide();

    $.post(
        RQ_URL + "/SLAs/RemoveTempSlaGoalConditions",
        {
        },
        "json"
        )
        .error(function (error) { alert(error.responseText); });
}

function SaveGoal(index) {
    var tr = $('#tableOfGoals tr[data-index="' + index + '"].goal-item');

    tr.find('div.editable .spanTimeOutFormat').hide();
    tr.find('div.editable .spanNoGoalCondition').hide();

    var error = false;

    var timeout = tr.find('div.editable input[type="text"].tbTimeOut').val();

    if (timeout.trim() != '') {
        if (!(/^ *([0-9]*h)? ?([0-9]*m)? *$/.test(timeout))) {
            tr.find('div.editable .spanTimeOutFormat').show();
            error = true;
        }
    }

    if (editedSlaGoalConditions.length == 0 && tr.find('div.div-conditions').is(':empty')) {
        tr.find('div.editable .spanNoGoalCondition').show();
        error = true;
    }

    if (!error) {
        tr.find('.btSaveGoal').addClass("loading-16");

        editedSlaGoalConditions.push({ name: 'index', value: index });
        editedSlaGoalConditions.push({ name: 'timeout', value: tr.find('div.editable input[type="text"].tbTimeOut').val() });
        editedSlaGoalConditions.push({ name: 'calendarId', value: tr.find('div.editable select.ddlCalendars').val() }); //prida dalsi parametry
        editedSlaGoalConditions.push({ name: 'sendEmail', value: tr.find('div.editable input[type="checkbox"].cbSendEmail').is(':checked') }); //prida dalsi parametry

        $.post(
            RQ_URL + "/SLAs/SaveGoal",
            editedSlaGoalConditions,
            function (data) {
            },
            "json"
            )
            .error(function (error) { alert(error.responseText); })
            .success(function () { ReloadTableOfGoals(true); })
            .done(function () { tr.find('.btSaveGoal').removeClass("loading-16"); });
    }
}


/// SECTION CONDITIONS ///
function AddItem(type) {

    var options = "";
    var options2 = "";

    $.ajax({
        url: RQ_URL + "/SLAs/GetConditionsFieldValues",
        context: document.body,
        async: false
    }).done(function (data) {
        var currentGroupKey;
        var groupOpened = false;

        $(data).each(function () {

            if (currentGroupKey != this.GroupKey) {
                currentGroupKey = this.GroupKey;

                if (groupOpened) {
                    options += "</optgroup>";
                }

                options += '<optgroup label="' + this.GroupName + '" value="' + this.GroupKey + '">';
                groupOpened = true;
            }

            var htmlattributes = "";
            $(this.HtmlAttributes).each(function () {
                htmlattributes += " " + this.Name + "='" + this.Value + "'";
            });

            options += "<option value='" + this.Value + "'" + htmlattributes + ">" + this.Text + "</option>";

        });

        if (groupOpened) {
            options += "</optgroup>";
        }
    });

    $.ajax({
        url: RQ_URL + "/SLAs/GetConditionsEnumeratorOrDataType?ruleId=1",
        context: document.body,
        async: false
    }).done(function (data) {
        $(data.options).each(function () {
            options2 += "<option value='" + this.Value + "'>" + this.Text + "</option>";
        });
    });

    var pos = $("tr." + type + "-row").length;
    var row = '<tr class="' + type + '-row">' +
                '<td><select id="' + type + '_' + pos + '__FilterColumn" name="' + type + '[' + pos + '].FilterColumn" onchange="RuleFieldChanged(' + pos + ',\'' + type + '\')">' + options + '</select></td>' +
                '<td>' +
                    '<select id="' + type + '_' + pos + '__FilterOperator" name="' + type + '[' + pos + '].FilterOperator"><option value="1">' + Localization_Is + '</option><option value="2">' + Localization_IsNot + '</option></select> ' +
                    '<select id="' + type + '_' + pos + '__FilterStringValue" name="' + type + '[' + pos + '].FilterStringValue">' + options2 + '</select>' +
                '</td>' +
                '<td>' +
                    '<img class="hand" src="' + RQ_URL + '/Content/img/icon-cross.png" alt="' + Localization_Delete + '" title="' + Localization_Delete + '" onclick="javascript:RemoveRow(' + pos + ',\'' + type + '\')"/>' +
                    '<input id="' + type + '_' + pos + '__RowType" type="hidden" value="' + type + '" name="' + type + '[' + pos + '].RowType" />' +
                    '<input id="' + type + '_' + pos + '__index" type="hidden" value="' + pos + '" name="' + type + '[' + pos + '].index" />' +
                    '<input id="' + type + '_' + pos + '__PriorityId" type="hidden" value="" name="' + type + '[' + pos + '].PriorityId" />' +
                    '<input id="' + type + '_' + pos + '__CategoryId" type="hidden" value="" name="' + type + '[' + pos + '].CategoryId" />' +
                '</td>' +
              '</tr>';

    $("tr.add-item-" + type).before(row);
}

function RuleFieldChanged(row, type) {

    var options = "";
    var ruleId = $("#" + type + "_" + row + "__FilterColumn").val();
    var priorityId = $("#" + type + "_" + row + "__FilterColumn option:selected").data('priorityid');
    var categoryId = $("#" + type + "_" + row + "__FilterColumn option:selected").data('categoryid');

    $.ajax({
        url: RQ_URL + "/SLAs/GetConditionsOperatorValues?RuleId=" + ruleId,
        context: document.body,
        async: false
    }).done(function (data) {
        $("#" + type + "_" + row + "__FilterOperator option").remove();
        $(data).each(function () {
            options += "<option value='" + this.Value + "'>" + this.Text + "</option>";
        });
        $("#" + type + "_" + row + "__FilterOperator").html(options);
        $("#" + type + "_" + row + "__PriorityId").val(priorityId);
        $("#" + type + "_" + row + "__CategoryId").val(categoryId);
    });

    options = "";

    $.ajax({
        url: RQ_URL + "/SLAs/GetConditionsEnumeratorOrDataType?ruleId=" + ruleId + "&priorityId=" + priorityId + "&categoryId=" + categoryId,
        context: document.body,
        async: false
    }).done(function (data) {

        $("#" + type + "_" + row + "__FilterStringValue").remove();
        var operator_ddl = $("#" + type + "_" + row + "__FilterOperator");

        if (data.type == "spinner") {
            operator_ddl.after(' <input type="text" value="1" class="spinner" id="' + type + '_' + row + '__FilterStringValue" name="' + type + '[' + row + '].FilterStringValue" />');
            InitSpinnersAndDatePickers();
        }
        else if (data.type == "dropdown") {
            operator_ddl.after(' <select id="' + type + '_' + row + '__FilterStringValue" name="' + type + '[' + row + '].FilterStringValue"></select>');
            $(data.options).each(function () {
                options += "<option value='" + this.Value + "'" + (this.Disabled ? " disabled" : "") + ">" + htmlEncode(this.Text) + "</option>";
            });
            $("#" + type + "_" + row + "__FilterStringValue").html(options);
        }
    });
}

function InitSpinnersAndDatePickers() {
    $('.spinner').spinner({ min: 1, max: 999 });
    $(".datepicker").datepicker();
}

function RemoveRow(row, type) {

    $("tr." + type + "-row:eq(" + row + ")").remove();
    ReIndex(type);
}

function ReIndex(type) {

    $("tr." + type + "-row").each(function (index) {

        $("img", this).attr("onclick", "javascript:RemoveRow(" + index + ",'" + type + "')");

        $("select, input", this).each(function () {

            var select = $(this);
            var id = select.attr("id");
            var pos = id.lastIndexOf("_");
            if (pos != -1) {
                id = id.substring(pos + 1);
                select.attr("id", "" + type + "_" + index + "__" + id);
                select.attr("name", "" + type + "[" + index + "]." + id);

                if (select.attr("onchange"))
                    select.attr("onchange", "RuleFieldChanged(" + index + ",'" + type + "')");
            }
            else
                alert("Reindex failed");
        });
    });
}


/// SECTION ESCALATIONS ///

function AddEscalation() {
    $('#spanEscalationTimeOutFormat').hide();
    $('#spanEscalateToUsersError').hide();

    var error = false;

    if ($('#ddlEscalationImmediatelyBeforeAfter').val() != "0") {
        if ($('#tbEscalationTimeOut').val().trim() == '' || !(/^ *([0-9]*d)? ?([0-9]*h)? ?([0-9]*m)? *$/.test($('#tbEscalationTimeOut').val()))) {
            $('#spanEscalationTimeOutFormat').show();
            error = true;
        }
    }

    if ($('#ddlEscalateToUsersAdd').val() == null || $('#ddlEscalateToUsersAdd').val() == '') {
        $('#spanEscalateToUsersError').show();
        error = true;
    }

    if (!error) {
        $('#btAddEscalation').addClass("loading-16");

        $.post(
            RQ_URL + "/SLAs/AddEscalation",
            {
                immediatelyBeforeAfter: $('#ddlEscalationImmediatelyBeforeAfter').val(),
                timeout: $('#tbEscalationTimeOut').val(),
                users: $('#ddlEscalateToUsersAdd').val(),
            },
            function (data) {
                if (data.success) {
                    ReloadTableOfEscalations();
                } else {
                    $('#spanEscalationTimeOutFormat').show();
                }
            },
            "json"
            )
            .error(function (error) { alert(error.responseText); })
            .success(function () {  })
            .done(function () { $('#btAddEscalation').removeClass("loading-16"); });
    }
}

function ReloadTableOfEscalations(quiet) {
    if (!quiet) { OnAjaxBegin(); }

    $("#tableOfEscalations").load(
        RQ_URL + "/SLAs/PartialTableOfEscalations",
        function () {
            $("#ddlEscalateToUsersAdd").select2({ width: 'resolve' });
            $("select.ddlEscalateToUsers").select2({ width: 'resolve' });
            if (!quiet) { OnAjaxComplete(); }
        }
    );
}

function DeleteEscalation(index) {
    OnAjaxBegin();

    $.post(
        RQ_URL + "/SLAs/DeleteEscalation",
        {
            index: index,
        },
        "json"
        )
        .error(function (error) { alert(error.responseText); })
        .success(function () { ReloadTableOfEscalations(); })
        .done(function () { OnAjaxComplete(); });
}

function EditEscalation(index) {
    $('#tableOfEscalations tr.escalation-item div.editable').hide();
    $('#tableOfEscalations tr.escalation-item div.readonly').show();

    var tr = $('#tableOfEscalations tr[data-index="' + index + '"].escalation-item');

    tr.find('div.editable select.ddlEscalationImmediatelyBeforeAfter').val(tr.find('div.editable input[type="hidden"].ddlEscalationImmediatelyBeforeAfter').val());
    tr.find('div.editable input[type="text"].tbEscalationTimeOut').val(tr.find('div.editable input[type="hidden"].tbEscalationTimeOut').val());

    if (tr.find('div.editable select.ddlEscalationImmediatelyBeforeAfter').val() == "0") {
        tr.find('div.editable .spanEscalationTimeOut').hide();
    } else {
        tr.find('div.editable .spanEscalationTimeOut').show();
    }

    var arr = tr.find('div.editable input[type="hidden"].ddlEscalateToUsers').map(function () {
        return this.getAttribute("value");
    }).get();

    tr.find('div.editable select.ddlEscalateToUsers').val(arr).trigger("change");

    tr.find('div.readonly').hide();
    tr.find('div.editable').show();
}

function CancelEditEscalation(index) {
    var tr = $('#tableOfEscalations tr[data-index="' + index + '"].escalation-item');

    tr.find('div.editable').hide();
    tr.find('div.readonly').show();
    tr.find('div.editable .spanEscalationTimeOutFormat').hide();
    tr.find('div.editable .spanEscalateToUsersError').hide();
}

function SaveEscalation(index) {
    var tr = $('#tableOfEscalations tr[data-index="' + index + '"].escalation-item');

    tr.find('div.editable .spanEscalationTimeOutFormat').hide();
    tr.find('div.editable .spanEscalateToUsersError').hide();
    var error = false;

    var ddlEscalationImmediatelyBeforeAfter = tr.find('div.editable select.ddlEscalationImmediatelyBeforeAfter');
    var tbEscalationTimeOut = tr.find('div.editable input[type="text"].tbEscalationTimeOut');
    var ddlEscalateToUsers = tr.find('div.editable select.ddlEscalateToUsers');

    if (ddlEscalationImmediatelyBeforeAfter.val() != "0") {        
        if (tbEscalationTimeOut.val().trim() == '' || !(/^ *([0-9]*d)? ?([0-9]*h)? ?([0-9]*m)? *$/.test(tbEscalationTimeOut.val()))) {
            tr.find('div.editable .spanEscalationTimeOutFormat').show();
            error = true;
        }
    }

    if (ddlEscalateToUsers.val() == '') {
        tr.find('div.editable .spanEscalateToUsersError').show();
        error = true;
    }

    if (!error) {
        tr.find('.btSaveEscalation').addClass("loading-16");
        var slaEscalationId = tr.find('.hiddenSlaEscalationId').val();

        $.post(
            RQ_URL + "/SLAs/SaveEscalation",
            {
                index: index,
                slaEscalationId: slaEscalationId != '' ? slaEscalationId : null,
                immediatelyBeforeAfter: ddlEscalationImmediatelyBeforeAfter.val(),
                timeout: tbEscalationTimeOut.val(),
                users: ddlEscalateToUsers.val(),
            },
            function (data) {
                if (data.success) {
                    ReloadTableOfEscalations(true);
                } else {
                    tr.find('div.editable .spanEscalationTimeOutFormat').show();
                }
            },
            "json"
            )
            .error(function (error) { alert(error.responseText); })
            .success(function () { })
            .done(function () { tr.find('.btSaveEscalation').removeClass("loading-16"); });
    }
}

